/*
 * This file is part of the QPxTool project.
 * Copyright (C) 2008-2009 Gennady "ShultZ" Kozlov <qpxtool@mail.ru>
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 * See the file "COPYING" for the exact licensing terms.
 * */

#ifndef PREF_COLORS_H
#define PREF_COLORS_H

#include <QWidget>

class QBoxLayout;
class QGridLayout;

class ColorLabel;
class QPxSettings;

class prefColors : public QWidget
{
	Q_OBJECT
public:
	prefColors(QPxSettings *iset, QWidget *p=0, Qt::WindowFlags fl=0);
	~prefColors();

private:
	QGridLayout  *layout;

	ColorLabel	*lc_bg;
	ColorLabel	*lc_grid;

	ColorLabel	*lc_rspeed;
	ColorLabel	*lc_wspeed;

	ColorLabel	*lc_errc[8];

	ColorLabel	*lc_jitter;
	ColorLabel	*lc_asymm;

	ColorLabel	*lc_fe;
	ColorLabel	*lc_te;

	ColorLabel	*lc_tapit;
	ColorLabel	*lc_taland;

	QPxSettings *set;
};

#endif

